#載入 tcoreapi
from tcoreapi_mq import * 
#載入我們提供的行情 function
from quote_functions import *
import threading

#建立 ZMQ 聯綫

#設定連綫授權碼，通常不用改。
g_QuoteZMQ = QuoteAPI("ZMQ","8076c9867a372d2a9a814ae710c256e2")

#設定連接 Port，通常不用改 3.0 = 51237, 4.0 = 50774。
#如果無法連線，可能是 port 被占用，可以到 TC安裝路徑\APPs\TCoreRelease\Logs 找日期最新的 QuoteZMQService-xxxxxx-0.log
#搜尋  RepPort: ，即可取得連線 Port
q_data = g_QuoteZMQ.Connect("50774")

if q_data["Success"] != "OK":
    #連線失敗。
    print("[ quote ]connection failed")
    print("連線失敗!\n可能是 port 被占用，請到 TC安裝路徑\\APPs\\TCoreRelease\\Logs \n找日期最新的 QuoteZMQService-xxxxxx-0.log 搜尋  RepPort: ，即可取得連線 Port")
else:

    #連綫成功后，將取得的 Session Key 儲存下來，後面調用指令需要帶入。
    g_QuoteSession = q_data["SessionKey"]

    #建立一個執行緒用來處理即時行情與歷史資料
    thread_stop = False
    t1 = threading.Thread(target = quote_sub_th,args=(g_QuoteZMQ,q_data["SubPort"], lambda: thread_stop))
    t1.start()
    
    #設定合約代碼，測試時請注意範例的合約是否已經下市。
    #使用 HOT 可以取得連續月資料
    testSymbol = "TC.F.TWF.TXF.HOT"

    #訂閱歷史數據
    # message["DataType"]="TICKS"   ticks
    # message["DataType"]="1K"   1K
    # message["DataType"]="DK"   日K
    # message["DataType"]="DOGSS"   Greeks 秒數據
    # message["DataType"]="DOGSK"   Greeks 分鐘數據
    # 回補區間設定
    # yyyymmddHH, HH 00-23
    # 請特別注意，我們提供的是 +0 的時間，所以如果你需要取得台灣 +8 的時間
    # 例如：下午 1500 - 1700，請自己先減 8，HH 07-09
    # 取得的資料，請再自己 +8，轉換為台灣時區
    ktype = '1K'
    sD = '2024013007'
    eD = '2024013009'

    df = GetHistory(g_QuoteZMQ, g_QuoteSession, testSymbol, ktype, sD, eD)
    
    #列印下載完成的歷史資料
    print( df )

    print("展示完成....")
    thread_stop = True
    #斷開連線
    g_QuoteZMQ.Logout(g_QuoteSession)
    print("中斷連線中...")